SystemOrganization addCategory: #'Pier-Blog-Model'!
SystemOrganization addCategory: #'Pier-Blog-Seaside'!

PRPage subclass: #PBComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Model'!

!PBComment class methodsFor: 'testing' stamp: 'lr 1/1/2007 00:39'!
canBeChildOf: aClass
	^ aClass includesBehavior: PBPost! !

!PBComment class methodsFor: 'testing' stamp: 'lr 1/1/2007 00:40'!
canBeParentOf: aClass
	^ aClass includesBehavior: PBComment! !

PRPage subclass: #PBPost
	instanceVariableNames: 'author link publication visibility'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Model'!

!PBPost class methodsFor: 'testing' stamp: 'lr 1/1/2007 00:42'!
canBeParentOf: aClass
	^ aClass includesBehavior: PBComment! !

!PBPost class methodsFor: 'accessing-descriptions' stamp: 'lr 1/3/2007 07:21'!
descriptionAuthor
	^ (MAStringDescription selector: #author label: 'Author' priority: 110)
		comment: 'The author of this post.';
		beEditable;
		yourself! !

!PBPost class methodsFor: 'accessing-descriptions' stamp: 'lr 1/3/2007 07:21'!
descriptionLink
	^ (MAStringDescription selector: #link label: 'Link' priority: 120)
		comment: 'The link this post should refer to, can be left empty to point to the post iteself.';
		beEditable;
		yourself! !

!PBPost class methodsFor: 'accessing-descriptions' stamp: 'lr 1/3/2007 07:21'!
descriptionPublication
	^ (MATimeStampDescription selector: #publication label: 'Publication' priority: 130)
		comment: 'The publication date of this post.';
		beEditable;
		yourself! !

!PBPost class methodsFor: 'accessing-descriptions' stamp: 'lr 1/3/2007 07:22'!
descriptionVisibility
	^ (MABooleanDescription selector: #visibility label: 'Visibility' priority: 140)
		comment: 'The visibility of this post in the generated feeds.';
		beEditable;
		yourself! !

!PBPost methodsFor: 'accessing' stamp: 'lr 1/3/2007 07:07'!
author
	^ author ifNil: [ author := self defaultAuthor ]! !

!PBPost methodsFor: 'accessing' stamp: 'lr 1/3/2007 07:07'!
author: aString
	author := aString! !

!PBPost methodsFor: 'configuration' stamp: 'lr 1/3/2007 07:14'!
defaultAuthor
	((self respondsTo: #owner) and: [ self owner notNil ])
		ifTrue: [ ^ self owner name ].
	^ nil! !

!PBPost methodsFor: 'configuration' stamp: 'lr 1/3/2007 07:16'!
defaultPublication
	^ TimeStamp now! !

!PBPost methodsFor: 'configuration' stamp: 'lr 1/3/2007 07:18'!
defaultVisibility
	^ false! !

!PBPost methodsFor: 'accessing' stamp: 'lr 1/3/2007 07:11'!
link
	^ link! !

!PBPost methodsFor: 'accessing' stamp: 'lr 1/3/2007 07:11'!
link: aString
	link := aString! !

!PBPost methodsFor: 'accessing' stamp: 'lr 1/3/2007 07:15'!
publication
	^ publication ifNil: [ publication := self defaultPublication ]! !

!PBPost methodsFor: 'accessing' stamp: 'lr 1/3/2007 07:15'!
publication: aTimeStamp
	publication := aTimeStamp! !

!PBPost methodsFor: '*pier-blog-seaside' stamp: 'lr 1/3/2007 07:42'!
viewComponentClass
	^ PBPostView! !

!PBPost methodsFor: 'accessing' stamp: 'lr 1/3/2007 07:18'!
visibility
	^ visibility ifNil: [ visibility := self defaultVisibility ]! !

!PBPost methodsFor: 'accessing' stamp: 'lr 1/3/2007 07:19'!
visibility: aBoolean
	visibility := aBoolean! !

PRDefaultView subclass: #PBPostView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBPostView methodsFor: 'accessing' stamp: 'lr 1/3/2007 07:57'!
comments
	^ self context enumerator
		sort: [ :a :b | a publication < b publication ];
		select: [ :each | each isComment ]! !

!PBPostView methodsFor: 'rendering' stamp: 'lr 1/3/2007 07:57'!
renderContentOn: html
	super renderContentOn: html.
	self renderToolsOn: html! !

!PBPostView methodsFor: 'rendering' stamp: 'lr 1/3/2007 07:59'!
renderToolsOn: html
	| comments |
	comments := self comments.
	comments isEmpty ifFalse: [
		html anchor
			callback: [ ] ]! !
